// PnClientSDK.h

#ifndef __NR_CLIENT_SDK_H

#define __NR_CLIENT_SDK_H


#ifdef  NR_CLIENT_SDK_API
 #define NRCLIENTSDK_API  extern "C" __declspec(dllexport)
#else
 #define NRCLIENTSDK_API  extern "C" __declspec(dllimport)
#endif


#ifndef    NULL
 #define	   NULL 0
#endif


//ǩ
typedef struct _NRCLIENTSDK_CARD
{
   unsigned long  slot;           //վ
   unsigned long  cardNo;         //
   unsigned char  attr;
   unsigned char extData[7];
   char  rssi;
   //unsigned long  isLowPower;     //ǷǷѹ
   //int  distance;       //
}NRCLIENTSDK_CARD, *LNRCLIENTSDK_CARD;

//бǩ
typedef struct _NRCLIENTSDK_CALL_CARD
{
   unsigned long  cardNo;         //
   unsigned char  mode;           //ģʽ
}NRCLIENTSDK_CALL_CARD, *LNRCLIENTSDK_CALL_CARD;


//¼ص
//evt    ¼
//devIp  IP
//card   ĿϢ
typedef int (__stdcall  * NrClientSDK_Event_CallBack)(int evt, int result, char * devIp, LNRCLIENTSDK_CARD card);


/********************************* ص¼ evt *****************************************/                                                                                
#define EVENT_CONNECT_OK                     1    //ӳɹ                 
#define EVENT_DISCONNECT                     3    //Ͽ                           
#define EVENT_CARD_READ                      4    //ȡǩϢ 
#define EVENT_CALL_ACK                       5    //ȷ
#define EVENT_SMS_ACK                        6    //ȷ϶Ϣ
#define EVENT_BULK_CALL_ACK                  7    //ȷ


/*******ֵ******/
#define NRCLIENTSDK_OK                            0     //OK
#define NRCLIENTSDK_ERR_READER_NOT_CONNECT        1    //δ
#define NRCLIENTSDK_ERR_READER_TIMEOUT            2    //ʱ
#define NRCLIENTSDK_ERR_READER_ALREADY_EXIST      3    //Ѵ
#define NRCLIENTSDK_ERR_READER_READER_NOT_EXIST   4    //δ
#define NRCLIENTSDK_ERR_SDK_NOT_INIT              5    //SDKδʼ
#define NRCLIENTSDK_ERR_PARAM_WRONG               6    //
#define NRCLIENTSDK_ERR_DEV_COUNT_REACH_MAX       7    //豸ﵽ
#define NRCLIENTSDK_ERR_SLOT_NOT_EXIST            8    //վδ
#define NRCLIENTSDK_ERR_READER_BUF_FULL           9    //

/********************************SDKӿں*********************************/
//ʼSDK
//   ver   [out]   SDK汾
//ֵ  0 ɹ  㣺ʧֵ
NRCLIENTSDK_API int __stdcall NrClientSDK_Init(char * ver, NrClientSDK_Event_CallBack eventCb);

//һ
//   devIp   IPַ
//ֵ  0 ɹ  㣺ʧֵ
NRCLIENTSDK_API int __stdcall NrClientSDK_NewReader(char  * devIp);

//ɾһ
//   devIp   IPַ
//ֵ  0 ɹ  㣺ʧֵ
NRCLIENTSDK_API int __stdcall NrClientSDK_DelReader(char  * devIp);


//
// devIp  ַ
//     slot    վַ
//     CardNo ǩID
//     mode  ģʽ 0   1 +
//     keepSeconds  ѳ  (1 - 240)
//ֵ  0 ɹ  㣺ʧֵ
NRCLIENTSDK_API int __stdcall NrClientSDK_CallLabel(char  * devIp, unsigned long slot, unsigned long cardNo, unsigned long mode, unsigned long keepSeconds);


//
// devIp  ַ
//     slot    վַ
//     keepSeconds  ѳ  (1 - 240)
//     callCard Ҫеıǩ
//     cardNum  Ҫеıǩ80)
//ֵ  0 ɹ  㣺ʧֵ
NRCLIENTSDK_API int __stdcall NrClientSDK_BulkCallLabel(char  * devIp, unsigned long slot, unsigned long keepSeconds, LNRCLIENTSDK_CALL_CARD callCard, unsigned long cardNum);




//֪ͨ
// devIp    ַ
//     slot     վַ
//     CardNo   ǩID
//     mode     ű
//     content  
//ֵ  0 ɹ  㣺ʧֵ
NRCLIENTSDK_API int __stdcall NrClientSDK_SmsNotify(char  * devIp, unsigned long slot, unsigned long cardNo, unsigned long code, const char *  content);



//򿪵
//  
//ֵ  0 ɹ  㣺ʧֵ
NRCLIENTSDK_API int __stdcall NrClientSDK_OpenTelnetDebug(unsigned short port);

//رյ
//  
//ֵ  0 ɹ  㣺ʧֵ
NRCLIENTSDK_API int __stdcall NrClientSDK_CloseTelnetDebug(void);


#endif
